import { renderless, api } from "@xmweb-ui/vue-renderless/split/vue";
import { defineComponent, props, setup as _setup } from "@xmweb-ui/vue-common";
import { iconChevronRight } from "@xmweb-ui/vue-icon";
function normalizeComponent(scriptExports, render, staticRenderFns, functionalTemplate, injectStyles, scopeId, moduleIdentifier, shadowMode) {
  var options = typeof scriptExports === "function" ? scriptExports.options : scriptExports;
  if (render) {
    options.render = render;
    options.staticRenderFns = staticRenderFns;
    options._compiled = true;
  }
  if (functionalTemplate) {
    options.functional = true;
  }
  if (scopeId) {
    options._scopeId = "data-v-" + scopeId;
  }
  var hook;
  if (moduleIdentifier) {
    hook = function hook2(context) {
      context = context || // cached call
      this.$vnode && this.$vnode.ssrContext || // stateful
      this.parent && this.parent.$vnode && this.parent.$vnode.ssrContext;
      if (!context && typeof __VUE_SSR_CONTEXT__ !== "undefined") {
        context = __VUE_SSR_CONTEXT__;
      }
      if (injectStyles) {
        injectStyles.call(this, context);
      }
      if (context && context._registeredComponents) {
        context._registeredComponents.add(moduleIdentifier);
      }
    };
    options._ssrRegister = hook;
  } else if (injectStyles) {
    hook = shadowMode ? function() {
      injectStyles.call(this, (options.functional ? this.parent : this).$root.$options.shadowRoot);
    } : injectStyles;
  }
  if (hook) {
    if (options.functional) {
      options._injectStyles = hook;
      var originalRender = options.render;
      options.render = function renderWithStyleInjection(h, context) {
        hook.call(context);
        return originalRender(h, context);
      };
    } else {
      var existing = options.beforeCreate;
      options.beforeCreate = existing ? [].concat(existing, hook) : [hook];
    }
  }
  return {
    exports: scriptExports,
    options
  };
}

var __vue2_script = defineComponent({
  emits: ["moving", "mousemove", "mouseup", "moveend", "movestart", "update:modelValue", "collapsedChange"],
  props: [].concat(props, ["modelValue", "mode", "leftTopMin", "rightBottomMin", "collapsible"]),
  components: {
    IconChevronRight: iconChevronRight()
  },
  setup: function setup(props2, context) {
    return _setup({
      props: props2,
      context,
      renderless,
      api
    });
  }
});
var render = function render2() {
  var _vm = this;
  var _h = _vm.$createElement;
  var _c = _vm._self._c || _h;
  return _c("div", {
    ref: "outerWrapper",
    class: _vm.state.wrapperClasses
  }, [_vm.state.isHorizontal ? _c("div", {
    class: _vm.state.prefix + "-horizontal"
  }, [_c("div", {
    staticClass: "left-pane",
    class: _vm.state.paneClasses,
    style: {
      right: _vm.state.collapsed ? "100%" : _vm.state.anotherOffset + "%"
    }
  }, [_vm._t("left")], 2), _c("div", {
    class: _vm.state.prefix + "-trigger-con",
    style: {
      left: _vm.state.collapsed ? "2px" : _vm.state.offset + "%"
    },
    on: {
      "mousedown": _vm.handleMousedown
    }
  }, [_vm._t("trigger", function() {
    return [_c("div", {
      class: [_vm.state.prefix + "-trigger", _vm.state.prefix + "-trigger-vertical"]
    }, [_c("div", {
      class: [_vm.state.prefix + "-trigger-bar-con", "vertical"]
    }, _vm._m(0), 0)])];
  })], 2), _vm.collapsible ? _c("div", {
    class: _vm.state.prefix + "-collapse-bar",
    style: {
      left: _vm.state.collapsed ? 0 : "calc(" + _vm.state.offset + "% - 2px)"
    },
    on: {
      "click": _vm.handleCollapse
    }
  }, [_c("icon-chevron-right", {
    style: {
      transform: "rotate(" + (_vm.state.collapsed ? "0deg" : "180deg") + ")"
    }
  })], 1) : _vm._e(), _c("div", {
    staticClass: "right-pane",
    class: _vm.state.paneClasses,
    style: {
      left: _vm.state.collapsed ? "0" : _vm.state.offset + "%"
    }
  }, [_vm._t("right")], 2)]) : _c("div", {
    class: _vm.state.prefix + "-vertical"
  }, [_c("div", {
    staticClass: "top-pane",
    class: _vm.state.paneClasses,
    style: {
      bottom: _vm.state.collapsed ? "100%" : _vm.state.anotherOffset + "%"
    }
  }, [_vm._t("top")], 2), _c("div", {
    class: _vm.state.prefix + "-trigger-con",
    style: {
      top: _vm.state.collapsed ? "2px" : _vm.state.offset + "%"
    },
    on: {
      "mousedown": _vm.handleMousedown
    }
  }, [_vm._t("trigger", function() {
    return [_c("div", {
      class: [_vm.state.prefix + "-trigger", _vm.state.prefix + "-trigger-horizontal"]
    }, [_c("div", {
      class: [_vm.state.prefix + "-trigger-bar-con", "horizontal"]
    }, _vm._m(1), 0)])];
  })], 2), _vm.collapsible ? _c("div", {
    class: _vm.state.prefix + "-collapse-bar",
    style: {
      top: _vm.state.collapsed ? 0 : "calc(" + _vm.state.offset + "% - 2px)"
    },
    on: {
      "click": _vm.handleCollapse
    }
  }, [_c("icon-chevron-right", {
    style: {
      transform: "rotate(" + (_vm.state.collapsed ? "90deg" : "270deg") + ")"
    }
  })], 1) : _vm._e(), _c("div", {
    staticClass: "bottom-pane",
    class: _vm.state.paneClasses,
    style: {
      top: _vm.state.collapsed ? "0" : _vm.state.offset + "%"
    }
  }, [_vm._t("bottom")], 2)])]);
};
var staticRenderFns = [function() {
  var _vm = this;
  var _h = _vm.$createElement;
  var _c = _vm._self._c || _h;
  return _vm._l(3, function(i) {
    return _c("i", {
      key: "trigger-" + i,
      class: _vm.state.prefix + "-trigger-bar"
    });
  });
}, function() {
  var _vm = this;
  var _h = _vm.$createElement;
  var _c = _vm._self._c || _h;
  return _vm._l(3, function(i) {
    return _c("i", {
      key: "trigger-" + i,
      class: _vm.state.prefix + "-trigger-bar"
    });
  });
}];
var __cssModules = {};
var __component__ = /* @__PURE__ */ normalizeComponent(__vue2_script, render, staticRenderFns, false, __vue2_injectStyles, null, null, null);
function __vue2_injectStyles(context) {
  for (var o in __cssModules) {
    this[o] = __cssModules[o];
  }
}
var pc = /* @__PURE__ */ function() {
  return __component__.exports;
}();
export {
  pc as default
};
